﻿Add-Type -Assembly System.Windows.Forms

$ch1_min = 0.9                                                                    #OKとする上限と下限
$ch1_max = 1.1
$ch2_min = 1.8
$ch2_max = 2.2
$ch3_min = 2.7
$ch3_max = 3.3
$ch4_min = 3.6
$ch4_max = 4.4

& 'C:\Program Files (x86)\Hantek6000\Scope.exe'                                    #付属アプリを起動する
while ( (Get-Process | Where-Object {$_.Name -match "scope"}) -eq $null ){}        #"scope"というプロセスが現れるまで待つ
start-sleep -Milliseconds 1000
[System.Windows.Forms.SendKeys]::SendWait("(% X)")
[System.Windows.Forms.SendKeys]::SendWait("%f")
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("{down 3}")
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("{enter}")
start-sleep -Milliseconds 10
$retry_cnt = 0
Set-Clipboard -Value "neko"
do{
    
    [System.Windows.Forms.SendKeys]::SendWait(".")
    [System.Windows.Forms.SendKeys]::SendWait("^a")
    [System.Windows.Forms.SendKeys]::SendWait("^c")
    start-sleep -Milliseconds 100
    $clip_board = Get-Clipboard -Format Text
    $retry_cnt = $retry_cnt + 1
    if( $retry_cnt -gt 10 ){
        break
    }
}while( $clip_board -ne "." )
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("^a")
[System.Windows.Forms.SendKeys]::SendWait("^x")
[System.Windows.Forms.SendKeys]::SendWait("voltage_check.set")
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("{enter}")
start-sleep -Milliseconds 100
[System.Windows.Forms.SendKeys]::SendWait("^r")
start-sleep -Milliseconds 1000
while ( ( [System.Windows.Forms.MessageBox]::Show( "実行しますか？", "実行確認", "YesNo", "Question" ) ) -eq "Yes") {    #実行するかどうか確認のダイアログを表示
    if( ( Get-Process | Where-Object {$_.Name -match "scope"} ) -eq $null ){    #付属アプリのプロセスが存在しなければ終了する
        exit
    }
    [System.Windows.Forms.SendKeys]::SendWait("^r")                                #Ctrl+rで波形観測スタート
    start-sleep -Milliseconds 1000
    [System.Windows.Forms.SendKeys]::SendWait("^s")                                #Ctrl+sで波形保存
    [System.Windows.Forms.SendKeys]::SendWait("{tab}")                            
    [System.Windows.Forms.SendKeys]::SendWait("{right 4}")                        #TABを1回、→を4回で"ALL"を選択
    [System.Windows.Forms.SendKeys]::SendWait("{enter}")
    $retry_cnt = 0
    Set-Clipboard -Value "neko"
    do{                                                                            #ファイルオープンダイアログの表示待ち
        
        [System.Windows.Forms.SendKeys]::SendWait(".")
        [System.Windows.Forms.SendKeys]::SendWait("^a")
        [System.Windows.Forms.SendKeys]::SendWait("^c")
        start-sleep -Milliseconds 100
        $clip_board = Get-Clipboard -Format Text
        $retry_cnt = $retry_cnt + 1
        if( $retry_cnt -gt 10 ){
            break
        }
    }while( $clip_board -ne "." )
    start-sleep -Milliseconds 10
    [System.Windows.Forms.SendKeys]::SendWait("^a")
    [System.Windows.Forms.SendKeys]::SendWait("^x")
    [System.Windows.Forms.SendKeys]::SendWait("test.txt")                        #保存ファイル名を指定
    [System.Windows.Forms.SendKeys]::SendWait("{enter}")
    start-sleep -Milliseconds 1000
    [System.Windows.Forms.SendKeys]::SendWait("{enter}")                        #"Save Data OK"のダイアログにOKを押す
    start-sleep -Milliseconds 500
    $txt = Get-Content test.txt                                                    #保存された波形データを読み込む
    $txt_ch1 = $txt[5..4100]                                                    #各Chごとに分割
    $txt_ch2 = $txt[4108..8203]
    $txt_ch3 = $txt[8211..12306]
    $txt_ch4 = $txt[12314..16409]
    $sum = 0.0                                                                    #各Chの平均値を算出
    $txt_ch1 | ForEach-Object -Process {$sum = $sum + [double]$_}
    $avg1 = $sum / 4096.0
    $sum = 0.0
    $txt_ch2 | ForEach-Object -Process {$sum = $sum + [double]$_}
    $avg2 = $sum / 4096.0
    $sum = 0.0
    $txt_ch3 | ForEach-Object -Process {$sum = $sum + [double]$_}
    $avg3 = $sum / 4096.0
    $sum = 0.0
    $txt_ch4 | ForEach-Object -Process {$sum = $sum + [double]$_}
    $avg4 = $sum / 4096.0

    if( $avg1 -ge $ch1_min -And $avg1 -le $ch1_max ){                            #各Chに対してOK/NGを判定する
        $ch1_judge = "OK"
    }else{
        $ch1_judge = "NG"
    }
    if( $avg2 -ge $ch2_min -And $avg2 -le $ch2_max ){
        $ch2_judge = "OK"
    }else{
        $ch2_judge = "NG"
    }
    if( $avg3 -ge $ch3_min -And $avg3 -le $ch3_max ){
        $ch3_judge = "OK"
    }else{
        $ch3_judge = "NG"
    }
    if( $avg4 -ge $ch4_min -And $avg4 -le $ch4_max ){
        $ch4_judge = "OK"
    }else{
        $ch4_judge = "NG"
    }
    $result = "Ch1:"+[string]$avg1+"[V]    "+$ch1_judge+"`n"+"Ch2:"+[string]$avg2+"[V]    "+$ch2_judge+"`n"+"Ch3:"+[string]$avg3+"[V]    "+$ch3_judge+"`n"+"Ch4:"+[string]$avg4+"[V]    "+$ch4_judge    #結果の文字列を生成
    if( $ch1_judge -eq "OK" -And $ch2_judge -eq "OK" -And $ch3_judge -eq "OK" -And $ch4_judge -eq "OK" ){    #全ChがOKであればOKダイアログを表示
        [System.Windows.Forms.MessageBox]::Show( $result, "OK", "Ok", "Information" )
    }else{
        [System.Windows.Forms.MessageBox]::Show( $result, "NG", "Ok", "Error" )                                #1chでもNGであればエラーダイアログを表示
    }
    Remove-Item test.txt
}
